/*
 * Intersection.h
 *
 *  Created on: Jun 6, 2013
 *      Author: arik
 */

#ifndef INTERSECTION_H_
#define INTERSECTION_H_
#include <math.h>
#include <exception>
#define MIN(x,y)	((x)<(y))?(x):(y)
#define MAX(x,y)	((x)>(y))?(x):(y)
#define POINT_NOT_FOUND Point(sqrt(-1.0),0)
using namespace std;
void resetPoints(int* points)
{
	for (int i = 0; i < 4; i++)
	{
		points[i] = -1;
	}
}
struct Point
{
public:
	float x;
	float y;
	bool legit;
	Point(float _x, float _y)
	{
		x = _x;
		y = _y;
		legit = true;
	}
	bool isLegit()
	{ // test for NAN
		return x == x && y == y;
	}
};
struct Line
{
public:
	float* points;
	int start;
	int size;
	Line(float pts[],int _size)
	{
		points = pts;
		start = 0;
		size = _size;

	}
	Line(float pts[], int strt, int sz)
	{
		points = pts;
		start = strt;
		size = sz;
	}
	Line(const Line& l)
	{
		points = l.points;
		start = l.start;
		size = l.size;
	}
//	Point getPointID(int index)
//	{
//		return Point(points[2 * index], points[2 * index + 1]);
//	}
	int getPoint1X()
	{
		return 2*start;
	}
	int getPoint1Y()
	{
		return 2*start + 1;
	}
	int getPoint2X()
	{
		return 2*start + 2*size;
	}
	int getPointY()
	{
		return 2*start + 2*size + 1;
	}
};

Point isLinefloatersectBase(double x1, double y1, double x2, double y2, double x3,
		double y3, double x4, double y4)
{
	double px = (((x1 * y2 - y1 * x2) * (x3 - x4)) - ((x1 - x2) * (x3 * y4 - y3
			* x4))) / (((x1 - x2) * (y3 - y4)) - ((y1 - y2) * (x3 - x4)));
	double py = (((x1 * y2 - y1 * x2) * (y3 - y4)) - ((y1 - y2) * (x3 * y4 - y3
			* x4))) / (((x1 - x2) * (y3 - y4)) - ((y1 - y2) * (x3 - x4)));
	if (min(x1, x2) < px && max(x1, x2) > px && min(y1, y2) < py && max(y1, y2)
			> py)
		if (min(x3, x4) < px && max(x3, x4) > px && min(y3, y4) < py && max(y3,
				y4) > py)
			return Point((float)px, (float)py);
	return POINT_NOT_FOUND;
}

Point isLineIntersect(Line line1, Line line2, int* pts)
{
		Point res = isLinefloatersectBase(line1.points[line1.getPoint1X()], line1.points[line1.getPoint1Y()],
				line1.points[line1.getPoint2X()], line1.points[line1.getPointY()], line2.points[line2.getPoint1X()],
				line2.points[line2.getPoint1Y()], line2.points[line2.getPoint2X()], line2.points[line2.getPointY()]);
		Point res2 = isLinefloatersectBase(line2.points[line2.getPoint1X()], line2.points[line2.getPoint1Y()],
				line2.points[line2.getPoint2X()], line2.points[line2.getPointY()], line1.points[line1.getPoint1X()],
				line1.points[line1.getPoint1Y()], line1.points[line1.getPoint2X()], line1.points[line1.getPointY()]);
		if (res.isLegit())
		{
			pts[0] = line1.getPoint1X()/2;
			pts[1] = line1.getPoint2X()/2;
			pts[2] = line2.getPoint1X()/2;
			pts[3] = line2.getPoint2X()/2;
			return res;
		}
		else if (res2.isLegit())
		{
			pts[0] = line2.getPoint1X()/2;

			pts[1] = line2.getPoint2X()/2;
			pts[2] = line1.getPoint1X()/2;

			pts[3] = line1.getPoint2X()/2;
			return res2;
		}
		resetPoints(pts);
	return POINT_NOT_FOUND;
}

Point isCurveIntersecting(Line line1, Line line2, int* points)
{
	if (line1.size == 1 && line2.size == 1)
		return isLineIntersect(line1, line2, points);
	Line line1p1(line1);
	Line line1p2(line1);
	Line line2p1(line2);
	Line line2p2(line2);
	if (line1p1.size > 1)
	{
		line1p1.size /= 2;
		line1p2.size = line1.size - line1p1.size;
		line1p2.start += line1p1.size;
	}
	if (line2p1.size > 1)
	{
		line2p1.size /= 2;
		line2p2.size = line2.size - line2p1.size;
		line2p2.start += line2p1.size;
	}
	if (isLineIntersect(line1p1, line2p1, points).isLegit())
		return isCurveIntersecting(line1p1, line2p1, points);
	if (isLineIntersect(line1p1, line2p2, points).isLegit())
		return isCurveIntersecting(line1p1, line2p2, points);
	if (isLineIntersect(line1p2, line2p1, points).isLegit())
		return isCurveIntersecting(line1p2, line2p1, points);
	if (isLineIntersect(line1p2, line2p2, points).isLegit())
		return isCurveIntersecting(line1p2, line2p2, points);
	resetPoints(points);
	return POINT_NOT_FOUND;
}

#endif /* INTERSECTION_H_ */
