#ifndef _STRUCTS_H_
#define _STRUCTS_H_

#include <GLES2/gl2.h>
#include <GLES2/gl2ext.h>

// gl handles
typedef struct{
	// shader program handles
	unsigned int	objectProgramID;
	unsigned int	greenProgramID;
	unsigned int	redProgramID;

	// object shaders gl attribute handles
	GLint			objectvertexHandle;
	GLint			normalHandle;
	GLint			textureCoordHandle;
	GLint			objectmvpMatrixHandle;
	GLint			texSampler2DHandle;

	// color shaders gl attribute handles
	GLint			colorvertexHandle;
	GLint			colormvpMatrixHandle;
}RoadGLParams;

// drawing arrays
typedef struct{
	const GLvoid* vertices;
	const GLvoid* normals;
	const GLvoid* indices;
	const GLvoid* texCoords;
	int numIndices;
}RoadPieceGLArrays;

// screen touch event
typedef struct{
	bool isTouchWaiting;
	float x;
	float y;
}TouchEvent;

#endif //_STRUCTS_H_